<?php
//debug
///////////////////////////////////////////////////////////////////////////
const API_URL = 'http://irij.lvtv.eu/v1/xml/';

const API_LIST_URL = 'http://irij.lvtv.eu/api/xml/';

const LVTV_ARCHIVE_URL_PREFIX = 'http://irij.lvtv.eu/dune/CACHE_LVTV';
const LVTV_ARCHIVE_ID = 'ico';

class LVTV_Api {

	const LVTV_URL = 'http://irij.lvtv.eu/v1/xml/';
	private $sid = null;
	private $sid_name = 'msid';
	private $id_tv = null;
	private $id_vod = null;
	private $id_radio = null;
	private $account = null;
	private $settings = null;
	private $is_logged = false;
	private $cookie = null;
	private $login_status = null;
	private $lvtv_url = null;
	public  $tv = null;
	public  $vod = null;
	public  $radio = null;
	private $free_space = null;
	private $total_size = null;
	

	public function get_sid(){ 
		return $this->sid; 
	}
	
	public function get_settings(){ 
		return $this->settings; 
	}

	public function get_account(){ 
		return $this->account; 
	}

	public function is_logged_in(){ 
		return $this->is_logged; 
	}
	
	public function get_lvtv_url(){ 
		$url = str_ireplace("/v1/xml/", "", API_URL);
		return $url;
	}
///////////////////////////////////////////////////////////////////////////
	public function get_dir_tree(&$plugin_cookies)
	{

		$plugin_dir = DuneSystem::$properties['install_dir_path'];
		
		$this->free_space = disk_free_space("$plugin_dir");
		$url_prefix = LVTV_Config::ARCHIVE_URL;
		$size_url = $url_prefix . '/size.txt';
		try
		{
			$doc_ = HD::http_get_document($size_url);
		}
		catch (Exception $e)
		{
			throw $this->dune_exception($e,'get_dir_tree(size_url) falled.', false);
		}

			if (is_null($doc_))
			{
               	hd_print("Failed to fetch archive size.txt from $size_url.");
            }
			else
			{
               	$this->total_size = intval($doc_);
               	hd_print("get dir tree: size = $this->total_size");
            }

				$items = array
				(
				
				array(
				PluginRegularFolderItem::media_url => LVTV_TvGroupListScreen::get_media_url_str($this->tv = '77'),
				PluginRegularFolderItem::caption => 'ТВ',
				PluginRegularFolderItem::view_item_params => array(
				ViewItemParams::icon_path => 'plugin_file://icons/tv.png',
				)
			    ),
			  
				array(
				PluginRegularFolderItem::media_url => LVTV_VodCategoryListScreen::get_media_url_str($this->vod = '78'),
				PluginRegularFolderItem::caption => 'Видеотека',
				PluginRegularFolderItem::view_item_params => array(
				ViewItemParams::icon_path => 'plugin_file://icons/videothek.png',
				)
			    ),
				
				array(
				PluginRegularFolderItem::media_url => LVTV_Radio_ChannelListScreen::get_media_url_str($this->radio = '74'),
				PluginRegularFolderItem::caption => 'Радио' ,
				PluginRegularFolderItem::view_item_params => array(
					ViewItemParams::icon_path => 'plugin_file://icons/radio.png',

				)
				),
		
				array(
				PluginRegularFolderItem::media_url => LVTV_SetupScreen::get_media_url_str(),
				PluginRegularFolderItem::caption => 'Настройки' ,
				PluginRegularFolderItem::view_item_params => array(
				ViewItemParams::icon_path => 'plugin_file://icons/settings.png',
				)
				),
				);

		return $items;
	}

///////////////////////////////////////////////////////////////////////////
    public function api_get_groups_tv()
    {
        try
        {
            $sid = $this->sid;
            $doc = API_LIST_URL . "channel_list";
            hd_print("--->>> get_list_group: $doc");
            $xml = $this->xml_fetch_channels($doc,0);
            return $xml;
        }
        catch (Exception $e)
        {
            throw $this->dune_exception($e,
                'Channel list request failed.', false);
        }
    }

///////////////////////////////////////////////////////////////////////////
	public function get_dir($cid){
		$doc = API_URL."get_dir?cid=$cid";
		hd_print("--->>> get_dir: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_dir failed.', false);
		}
		return $xml;
		
	}
///////////////////////////////////////////////////////////////////////////
	public function get_epg($day_start_ts,$channel_id){
		$doc = API_URL."get_epg?mid=$channel_id&time=$day_start_ts";
		hd_print("--->>> get_dir: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_epg falled.', true);
		}
		return $xml;
		
	}
///////////////////////////////////////////////////////////////////////////
	public function get_url_tv_lvtv($mid,$archive, $protect, $time_shift, &$plugin_cookies)
	{

		$doc = self::LVTV_URL . "get_media?mid=";

		if (intval($archive) > 0){
			if ($time_shift >=1){
			    $time_minus = $time_shift * 3600;
			    $archive = $archive - $time_minus;
			}
			$doc .= $mid."_".$archive;
			//hd_print("---> arch::$archive");
		}
		else
		{
			$doc .= $mid;
		}
			
		if (isset($protect) && $protect !== '')	
		{
			hd_print("---> protected::$protect");
			$doc .= "&protect_code=$protect";
		}
		
		#hd_print("---> get_url_tv: $doc");
		
		try
		{
			$xml = $this->xml_fetch($doc,0);
		}
		catch (Exception $e)
		{
			throw $this->dune_exception($e,'get_url_tv_lvtv failed.', true);
		}

		$url = strval($xml->url);

		if (intval($archive) > 0){
			$tmp_url = explode("&", $url);
			$url = $tmp_url[0]."&start=$archive";
		}
		if (strpos($url,"?") === false ){
		    $url .= "?$this->sid";
		}else{
		    $url .= "&$this->sid";
		}
		
		if (isset($protect) && $protect !== '')	{
		    $url .= "&protect_code=$protect";
		}		
		
		#$url = str_ireplace("http://","http://ts://127.0.0.1:1000/cgi-bin/arch?http://",$url);
		return $url;
	}
///////////////////////////////////////////////////////////////////////////
	public function unset_login(){
		hd_print("unset_login");
		$this->sid = null;
		$this->is_logged = false;
		$this->account = null;
		$this->settings = null;
		
	}
///////////////////////////////////////////////////////////////////////////
	public function check_login($plugin_cookies){
		hd_print("check_login");
		hd_print("sid:$this->sid");
		$is_login_correct = isset($plugin_cookies->is_login_correct) ? $plugin_cookies->is_login_correct : false;
		hd_print("is_login_corect:$is_login_correct");
		$is_logged = $this->is_logged_in();
		hd_print("is_logged:$is_logged");
		hd_print("!!!!xxxx!!!!");
		$is_log = isset($is_logged) ? $is_logged : false;
		if ($is_login_correct == 1 && $is_logged != 1){
			hd_print("Авторизация>");
			$this->login_lvtv($plugin_cookies);
			hd_print("sid1:$this->sid");
		}
		if($this->tv == null || $this->vod == null || $this->radio == 0 && $is_login_correct == 1){
			$this->get_dir_tree($plugin_cookies);	
		}
	}


///////////////////////////////////////////////////////////////////////////
	public function login_lvtv(&$plugin_cookies){
		if (!isset($plugin_cookies->login)) throw new Exception('Абонемент не введен');
		if (!isset($plugin_cookies->pass))  throw new Exception('Пароль не введен');
		
		
		$this->is_logged = false;
		$plugin_cookies->is_login_correct = false;
		
		if (isset($plugin_cookies->msid) && $plugin_cookies->msid!=''){
                    $doc = API_URL ."account?msid=$plugin_cookies->msid";
                    hd_print("--->>> account: $doc");
                    
                    try{
                            $xml = $this->xml_fetch($doc,1);                                                        
                            if (isset($xml->msid)){
                                $this->is_logged = true;
                                $plugin_cookies->is_login_correct = true;                                                        
                            }                            
                    }catch (Exception $e){
                            hd_print("msid auth falled");
                    }
                }

                if(!$this->is_logged){
                    $pass = $this->pass_lvtv($plugin_cookies->pass);
                    $doc = API_URL ."login?login=$plugin_cookies->login$pass";
                    hd_print("--->>> get_login: $doc");
                    try{
                            $xml = $this->xml_fetch($doc,1);
                            $this->is_logged = true;
                            $plugin_cookies->is_login_correct = true;
                    }catch (Exception $e){
                            hd_print("loged falled");
                            throw $this->dune_exception($e,'Ошибка авторизации', true);
                    }                                        
		}

		if (isset($xml->msid)){
			$this->sid = "msid=".strval($xml->msid);
			$plugin_cookies->msid = strval($xml->msid);
			hd_print("msid:$this->sid");
			#$this->cookie = array(CURLOPT_COOKIE => $this->sid);
			
                        $this->settings = $xml->settings;
                        $this->account = $xml->account;
		}
	}
	
	
	
	
    public function try_login(&$plugin_cookies, $for_play = true){
        hd_print('*** try_login()');
        if (!isset($plugin_cookies->user_name))
            throw new Exception('User name is not set');

		$this->plugin_cookies = $plugin_cookies;
        try
        {
            $this->login_lvtv($plugin_cookies);	
        }
        catch (Exception $e)
        {
            hd_print('*** try_login() - exception');
            $this->logout();
            throw $e;
        }
    }
/////////////////////////////////pass//////////////////////////////////////////
	private function pass_lvtv($pass){
		$unixtime = time();
		$hex = md5($unixtime.'*'.$pass);
		$password = "&time=$unixtime&hex=$hex";
		return $password;
	}
///////////////////////////////////////////////////////////////////////////
	public function logout_lvtv(&$plugin_cookies){
		$this->is_logged = false;
		$plugin_cookies->msid = '';
		$doc = API_URL."logout";
		hd_print("--->>> get_logout: $doc");
		try{
			$xml = $this->xml_fetch($doc,1);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_vod_info failed.', false);
		}
	}
///////////////////////////////////////////////////////////////////////////
	public function account_lvtv(&$plugin_cookies){
		$doc = API_URL."account";
		hd_print("--->>> get_account: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_vod_info failed.', false);
		}
	}
///////////////////////////////////////////////////////////////////////////
	public function status_lvtv(){
		$doc = API_URL."status";
		hd_print("--->>> get status: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_vod_info failed.', false);
		}
	}
///////////////////////////////////////////////////////////////////////////
	public function get_settings_lvtv(){
		$doc = API_URL."settings";
		hd_print("--->>> get settings: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_vod_info failed.', false);
		}
		$this->settings = $xml;
		return $xml;
	}
///////////////////////////////////////////////////////////////////////////
	public function set_settings_lvtv($control_id, $new_value){
		$doc = API_URL."settings?var=$control_id&val=$new_value";
		hd_print("--->>> set settings: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'set_settings failed.', false);
		}	
	}
	
	public function set_pcode_lvtv($old_code, $new_code, $confirm_code){
		$doc = API_URL."settings?var=pcode&val=$new_code&old_val=$old_code&confirm_val=$confirm_code";
		hd_print("--->>> set settings: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'set_settings failed.', false);
		}	

	}
///////////////////////////////////////////////////////////////////////////
	public function get_vod_info($mid){
	    	$doc = API_URL."get_vod_info?mid=$mid";
		try{
			$xml = $this->xml_fetch($doc, 0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'get_vod_info failed.', false);
		}
	    	return $xml;
	}
////////////////////////////добавление в фавориты видеотеки///////////////////////////////////////////////
	public function set_vod_favorites($mid){
		$doc = API_URL."set_vod_favorites?mid=$mid";
		hd_print("--->>> set settings: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'Ошибка добавления в список избранного видеотеки', false);
		}
		
	}
/////////////////////////////удаление из фаворитов видеотеки//////////////////////////////////////////////
	public function rm_vod_favorites($mid){
		$doc = API_URL."rm_vod_favorites?mid=$mid";
		hd_print("--->>> set settings: $doc");
		try{
			$xml = $this->xml_fetch($doc,0);
		}catch (Exception $e){
			throw $this->dune_exception($e,'Ошибка удаления из списка избранного', false);
		}
		
	}
/////////////////////////////список из фаворитов для видеотеки//////////////////////////////////////////////
        public function get_vod_favorites(){
                $doc = API_URL."get_vod_favorites";
                hd_print("--->>> set settings: $doc");
                try{
                        $xml = $this->xml_fetch($doc,0);
                }catch (Exception $e){
                        throw $this->dune_exception($e,'Ошибка загрузки списка избранного видеотеки', false);
                }
                return $xml;
        }

/////////////////////////////поиск для видеотеки//////////////////////////////////////////////
        public function get_vod_search($search,$sort_by){
		$search = urlencode($search);
                $doc = API_URL."search_vod?query=$search";
		if(isset($sort_by)){
			$doc .= "&sort_by=$sort_by";
		}
                hd_print("--->>> get search vod: $doc");
                try{
                        $xml = $this->xml_fetch($doc,0);
                }catch (Exception $e){
                        throw $this->dune_exception($e,'Ошибка поиска фильма в видеотеке', false);
                }
                return $xml;
        }
///////////////////////////////////////////////////////////////////////////
	public function xml_fetch($url,$islogin){
		#usleep(1000);
		if($islogin == 0){
			if (strpos($url,"?") === false ){
	    			$url .= "?$this->sid";
			}else{
	    			$url .= "&$this->sid";
			}
		}
		
		$doc = HD::http_get_document($url,$this->cookie);
		#hd_print("--->>> get_xml: $doc");
		$xml = simplexml_load_string($doc);
		if (is_null($doc)) throw new Exception("Can not fetch $doc");
		
       		if ($xml === false){
         		hd_print("Error: can not parse XML document.");
         		hd_print("XML-text: $doc.");
         		throw new Exception('Illegal XML document');
       		}

       		if ($xml->getName() !== 'response'){
			hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
			hd_print("XML-text: $doc.");
			throw new Exception('Invalid XML document');
       		}
        		
		if (isset($xml->error)){
			$num_error = intval($xml->error->code);
			hd_print("API error--> Code:$num_error Message: $xml->message URL:$url");
			$error_message = $this->get_error_message($xml->error->code,$xml->error->message);
			if($num_error == 31){
				hd_print('API: query limit exceeded');
              			continue;
			}
				
			throw new LVTV_Exception($error_message,$num_error);	
		}
		
		return $xml;			
	}
	public function xml_fetch_channels($url,$islogin){
		#usleep(1000);
		if($islogin == 0){
			if (strpos($url,"?") === false ){
	    			$url .= "?$this->sid";
			}else{
	    			$url .= "&$this->sid";
			}
		}
		
		$doc = HD::http_get_document($url,$this->cookie);
		#$doc = preg_replace('/<item><id>63<\/id><name>Все<\/name>.*<item><id>\-2<\/id><name>Фаворитные<\/name>/sU', '<item><id>-2</id><name>Фаворитные</name>', $doc);
		#hd_print("--->>> get_xml: $doc");
		$xml = simplexml_load_string($doc);
		
		if (is_null($doc)) throw new Exception("Can not fetch $doc");
		
       		if ($xml === false){
         		hd_print("Error: can not parse XML document.");
         		hd_print("XML-text: $doc.");
         		throw new Exception('Illegal XML document');
       		}

       		if ($xml->getName() !== 'response'){
			hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
			hd_print("XML-text: $doc.");
			throw new Exception('Invalid XML document');
       		}
        		
		if (isset($xml->error)){
			$num_error = intval($xml->error->code);
			hd_print("API error--> Code:$num_error Message: $xml->message URL:$url");
			$error_message = $this->get_error_message($xml->error->code,$xml->error->message);
			if($num_error == 31){
				hd_print('API: query limit exceeded');
              			continue;
			}
				
			throw new LVTV_Exception($error_message,$num_error);	
		}
		
		return $xml;			
	}
///////////////////////////////////////////////////////////////////////////
	public function get_error_message($num,$mesg){
		if($num == 0){
			$message = 'Неизвестная ошибка';
			
		}elseif($num == 1){
			$message = 'Неправильный запрос';
			
		}elseif($num == 2){
			$message = 'Неправильный абонемент или пароль';
			
		}elseif($num == 3){
			$message = 'Доступ заблокирован';
			
		}elseif($num == 4){
			$message = 'Неправильный абонемент или пароль';
			
		}elseif($num == 5){
			$message = 'Абонемент не активирован';
			
		}elseif($num == 6){
			$message = 'Действие абонемента приостановлено';
			
		}elseif($num == 11){
			$message = 'Абонемент используется на другом устройстве';
			
		}elseif($num == 12){
			$message = 'Ошибка авторизации';
			
		}elseif($num == 13){
			$message = 'Срок дейстия абонемента истек';
			
		}elseif($num == 15){
			$message = 'Архив не доступен';
			
		}elseif($num == 30){
			$message = 'Сервис не доступен';
			
		}elseif($num == 36){
			$message = 'Фильм не найден';
			
		}elseif($num == 37){
			$message = 'Фильм уже добавлен в избранное';
			
		}elseif($num == 51){
			$message = 'Абонемент заблокирован';
			
		}else{
			$message = strval($mesg);
			
		}
		return $message;
	}

///////////////////////////////////////////////////////////////////////////
	public function dune_exception($e, $def_caption, $is_playback){
       		$is_lvtv_error = ($e instanceof LVTV_Exception);
        	if (!$is_lvtv_error){
            		hd_print('General exception: ' . $e->getMessage());
            		$title = !$is_playback ? 'Error' : 'Отсутсвует подключение к Интернету.';
            		$text_lines = $is_playback ? array() : array('Сообщение системы: ' . $e->getMessage(), 'ошибка: ' . $e->getMessage());
                	
            		return new DuneException(
				$def_caption, -1,
                		ActionFactory::show_error(false, $title, $text_lines)
                	);
        	}
        	hd_print('LVTV API exception: ' .
            		'code=' . $e->getCode() . ', message=' . $e->getMessage());

        	$ecode = $e->getCode();
        	$fatal = $ecode == 5 || $ecode == 6 || $ecode == 11 || $ecode == 12 || $ecode == 13;

        	if ($fatal) $this->unset_login();

		if ($ecode == 2 || $ecode == 4){
			$this->is_logged = false;
		}
		
        	$title = !$is_playback ? 'Error' : $e->getMessage();
        	$text_lines = $is_playback ? array() : array('Сообщение системы: ' . $e->getMessage(), 'Ошибка: ' . $ecode);
        	
        	return new DuneException(
            		$def_caption, $ecode,
            		ActionFactory::show_error($fatal, $title, $text_lines)
            	);

		
	}

///////////////////////////////////////////////////////////////////////////
    public function do_get_edit_subscription_defs(&$plugin_cookies, $handler, $add_params){
		$defs = array();
		
		$login = isset($plugin_cookies->login) ? $plugin_cookies->login : '';
        	$pass = isset($plugin_cookies->pass) ? $plugin_cookies->pass : '';
		$lvtv_url = isset($plugin_cookies->lvtv_url) ? $plugin_cookies->lvtv_url : 'http://irij.lvtv.eu';
		ControlFactory::add_text_field(
			$defs, $handler, $add_params,
            		'login', 'Абонемент:',
            		$login, true, false, false, true, 500
            	);
        	ControlFactory::add_text_field(
			$defs, $handler, $add_params,
            		'pass', 'Пароль:',
            		$pass, true, true, false, false, 500
            	);
		#ControlFactory::add_text_field($defs,
            	#	$handler, $add_params,
            	#		'lvtv_url', 'URL сервера:',
            	#		$lvtv_url, false, false, false, true, 500);
        	ControlFactory::add_vgap($defs, 50);

        	ControlFactory::add_button(
			$defs, $handler, $add_params,
            		'apply_sub', null, 'Применить', 300
            	);

        	ControlFactory::add_vgap($defs, -3);

		ControlFactory::add_close_dialog_button($defs, 'Отменить', 300);

        	#ControlFactory::add_button($defs,$handler,$add_params,
            	#				'close',null,'Отменить', 300);

        	return $defs;
    }
/////////////////////////////////////////////////////////////////////////// 
    public function do_get_edit_subscription_action(&$plugin_cookies, $handler, $add_params = null){
        	return ActionFactory::show_dialog(
            		'Введите абонемент и пароль',
            		$this->do_get_edit_subscription_defs(
                	$plugin_cookies, $handler, $add_params),
            		true
            	);

    } 
///////////////////////////////////////////////////////////////////////////
    public function apply_sub(&$plugin_cookies, &$user_input){
        if (!isset($user_input->control_id) || $user_input->control_id != 'apply_sub'){
	    #hd_print("dalshe: $user_input->control_id");
            return false;
	}
	
	if ($user_input->control_id == 'close'){
		hd_print("close");
		return array(
		  'need_close_dialog' => true,
		  'action' =>ActionFactory::close_dialog()
		);
        }


        if ($user_input->login === '' || $user_input->pass === ''){
		return array(
		  'need_close_dialog' => false,
		  'action' =>ActionFactory::show_error(false,'Error',array('Поле Абонемент не может быть пустым.'))
		);
        }

	$plugin_cookies->login = $user_input->login;
	$plugin_cookies->pass = $user_input->pass;
	$plugin_cookies->msid = '';
	
	#$plugin_cookies->lvtv_url = $user_input->lvtv_url;
	$islogged = $this->is_logged_in();
	
	if ($islogged == true){
                hd_print("apply_sub: this->logout()");
        	$this->logout();
	}
	
        $post_action = null;
        
        try{
            $this->login_lvtv($plugin_cookies);
        }catch (DuneException $e){
            $post_action = $e->get_error_action();
        }
        
	if ($plugin_cookies->is_login_correct === 0){
		return array(
		    'need_close_dialog' => false,
		    'action' =>ActionFactory::show_error(false,'Error',array('Неправильный абонемент или пароль'))
                );
	}
	
        return array(
            'need_close_dialog' => true,
            'action' => $post_action
        );
    }
///////////////////////////////////////////////////////////////////////////

    public function get_archive(){
        return DefaultArchive::get_archive('ico', LVTV_Config::ARCHIVE_URL);
    }

    public function get_icon($icon){
	if($this->free_space >= $this->total_size){
        	$archive =  DefaultArchive::get_archive('ico',LVTV_Config::ARCHIVE_URL); 
        	return $archive->get_archive_url($icon);
	}else{
		$icon_url = LVTV_Config::ARCHIVE_URL.$icon;
		return $icon_url;
	} 
    }
	public function get_channel_icon($channel_id)
    {
        $archive = DefaultArchive::get_archive(
            LVTV_ARCHIVE_ID,
            LVTV_ARCHIVE_URL_PREFIX);
			
		return $archive->get_archive_url("$channel_id.png");
    }
}
///////////////////////////////////////////////////////////////////////////
?>
