<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';

class LVTV_EntryHandler
    implements UserInputHandler
{
    private $session;
    private $tv;

    public function __construct($session,$tv)
    {
        $this->session = $session;
	$this->tv = $tv;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_handler_id()
    {
        return 'entry';
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {

        hd_print('Entry handler: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");
		
        
        $open_folder_action = ActionFactory::open_folder();
       
        if (!isset($user_input->entry_id))
            return null;

        $add_params = array(
            'entry_id' => $user_input->entry_id);
        
        if ($user_input->entry_id === 'tv')
        {
			$check = $this->check_subscriptions($plugin_cookies);
            $res = $this->session->apply_sub($plugin_cookies, $user_input);
            if ($res !== false)
            {
				if (!isset($res['action']))
                {
                    return ActionFactory::close_dialog_and_run(
                        $open_folder_action);
                }

                return $res['need_close_dialog'] ?
                    ActionFactory::close_dialog_and_run($res['action']) :
                    $res['action'];
            }
            else
            {
                if ($this->session->is_logged_in() == 1)
				{
				if($user_input->entry_id !== 'setup')
					{
						$check = $this->check_subscriptions($plugin_cookies);
						if($check !== false)
							return $check;
					}
                    return $open_folder_action;
				}
			if(!isset($plugin_cookies->is_login_correct))
			{
				$plugin_cookies->is_login_correct = 0;
			}
					if ($this->session->is_logged_in() === false && $plugin_cookies->is_login_correct == 1)
			{
				hd_print("unloаd channеls<");
				$this->tv->unload_channels();
			}
                if (!isset($plugin_cookies->is_login_correct) ||
                    $plugin_cookies->is_login_correct == 0)
                {
					try
					{
					$this->session->login_lvtv($plugin_cookies);
					if($user_input->entry_id !== 'setup')
					{
					$check = $this->check_subscriptions($plugin_cookies);
					if($check !== false)
					return $check;
					}
					}
					catch (Exception $e)
					{
						return $this->session->do_get_edit_subscription_action(
							$plugin_cookies, $this, $add_params);
					}
                }

                return $open_folder_action;
            }
        }
	else 
	{
		hd_print("www");
		#return $open_folder_action;
		return ActionFactory::open_folder();
	}	
        return null;
    }
	private function check_subscriptions(&$plugin_cookies)
	{
		if($this->session->get_account() == null)
			$this->session->get_account();
	$this->session->check_login($plugin_cookies);		
	#############################################
	$acc_info = $this->session->get_account();
	$acc = isset($acc_info->expire) ? intval($acc_info->expire) : 0;
	#hd_print("ACC-------------->$acc");
	$time = shell_exec('date +%s');
	#hd_print("TIME-------------->$time");
	$diff = $acc - $time;
	#hd_print("DIFF-------------->$diff");
	if ($diff < 432000)
	{
	$day = ( $diff / 86400 ) % 30;
	$hour = ( $diff / 3600 ) % 24;
	$date = date('d.m.Y H:i', $acc);
	$post_action = null;
	$defs = array();
	#ControlFactory::add_label($defs, "", $this->rest($day) . $day . ' ' . $this->days($day) . ' подписки на наш сервис.');
	ControlFactory::add_label($defs, "", "Ваша подписка заканчивается $date");
	ControlFactory::add_label($defs, "", "Пожалуйста, продлите действие абонемента.");
	#ControlFactory::add_label($defs, "", "Это можно сделать на сайте lvtv.eu.");
	ControlFactory::add_label($defs, "", " ");
	ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'suscription_check_ok_id', 'OK', 150, ActionFactory::open_folder());
				
			return ActionFactory::show_dialog(
							'Уважаемый абонент!',
							$defs,
							true);
		
	}
	return false;
	#############################################
	}
	
	private function days($val)
	{
		if ($val == 1 || ($val % 10 == 1 && $val > 20)) return 'день';
		if ($val == 2 || ($val % 10 == 2 && $val > 20)) return 'дня';
		if ($val == 3 || ($val % 10 == 3 && $val > 20)) return 'дня';
		if ($val == 4 || ($val % 10 == 4 && $val > 20)) return 'дня';
		return 'дней';
	}
	private function rest($val)
	{
		if ($val == 1) return 'У Вас остался ';
		if ($val == 2 || ($val == 3)) return 'У Вас осталось ';
		return 'Осталось ';
	}
}

///////////////////////////////////////////////////////////////////////////
?>
