<?php
///////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////

class LVTV_MainCategoryListScreen extends AbstractPreloadedRegularScreen implements UserInputHandler {

    const ID = 'main_category_list';

    public static function get_media_url_str($category_id){
        return MediaURL::encode(
            array(
                'screen_id'     => self::ID,
                'category_id'   => $category_id,
            )
        );
    }

    ///////////////////////////////////////////////////////////////////////

    #private $category_list;
    private $session;
    
    ///////////////////////////////////////////////////////////////////////

    public function __construct($session){
        parent::__construct(self::ID, $this->get_folder_views());
	$this->session = $session;

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
	$actions = array();
        $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::open_folder();
        $settings_action = UserInputHandlerRegistry::create_action($this, 'settings');
        $settings_action['caption'] = 'Сменить иконки';
        #$actions[GUI_EVENT_KEY_B_GREEN] = $settings_action;
        
	return $actions;
    }
    
    public function get_handler_id(){ return self::ID; }
    
    ///////////////////////////////////////////////////////////////////////
    public function handle_user_input(&$user_input, &$plugin_cookies){
	hd_print('main_screen: handle_user_input:');
        foreach ($user_input as $key => $value) hd_print("  $key => $value");
        
        if ($user_input->control_id === 'settings'){
		if(!isset($plugin_cookies->main_icon)){
			$plugin_cookies->main_icon = 1;
		}
		
		hd_print('main_screen: icon settings');
		
		if($plugin_cookies->main_icon <= 1){
			$plugin_cookies->main_icon = 2;
		}else{
			$plugin_cookies->main_icon = 1;
		}
		
		$media_url_ = MediaURL::decode($user_input->parent_media_url);
		$sel_ndx = $user_input->sel_ndx;
		$range = HD::create_regular_folder_range($this->get_all_folder_items($media_url_, $plugin_cookies));
		
		return ActionFactory::update_regular_folder($range, false);
		
			
	}
	else{
		return null;
	}
    }
    
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
	$this->session->check_login($plugin_cookies);
        $items = $this->session->get_dir_tree($plugin_cookies);

        return $items;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_archive(MediaURL $media_url){ 
        return $this->session->get_archive();
    }
    ///////////////////////////////////////////////////////////////////////
    private function get_folder_views(){
    	return LVTV_Config::GET_MAIN_GROUP_LIST_FOLDER_VIEWS();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
