<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'lvtv_exception.php';
require_once 'lib/default_archive.php';

require_once 'lvtv_entry_handler.php';



require_once 'lib/tv/tv_favorites_screen.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'lib/vod/vod_search_screen.php';
require_once 'lib/vod/vod_genres_screen.php';
require_once 'lib/vod/vod_movie_screen.php';
require_once 'lib/vod/vod_series_list_screen.php';
require_once 'lib/vod/vod_favorites_screen.php';

require_once 'lvtv_tv_channel_list_screen.php';
require_once 'lvtv_config.php';
require_once 'lvtv_api.php';
require_once 'lvtv_tv.php';
require_once 'lvtv_setup_screen.php';
require_once 'lvtv_vod.php';
require_once 'lvtv_vod_category_list_screen.php';
require_once 'lvtv_vod_list_screen.php';
require_once 'lvtv_vod_category.php';
require_once 'lvtv_vod_cat.php';
require_once 'lvtv_vod_search_screen.php';
require_once 'lvtv_main_category_list_screen.php';
require_once 'lvtv_radio_channel_list_screen.php';
require_once 'lvtv_tv_group_list_screen.php';
///////////////////////////////////////////////////////////////////////////

class LVTV_Plugin extends DefaultDunePlugin {
    private $session;
    private $entry_handler;
    
    public function __construct(){
    
	$this->session = new LVTV_Api();
        $this->tv = new LVTV_Tv($this->session);
        $this->vod = new LVTV_Vod($this->session);
	$this->entry_handler = new LVTV_EntryHandler($this->session,$this->tv);
	
        $tv_folder_views = $this->get_tv_folder_views();

        $this->add_screen(new LVTV_SetupScreen($this->session,$this->tv));

        $this->add_screen(new LVTV_MainCategoryListScreen($this->session));

        $this->add_screen(new LVTV_TvGroupListScreen($this->tv,
                LVTV_Config::GET_TV_GROUP_LIST_FOLDER_VIEWS()));
                
        $this->add_screen(new LVTV_TvChannelListScreen($this->tv,
                LVTV_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS(),$this->session));
                
        $this->add_screen(new LVTV_Radio_ChannelListScreen($this->tv,
                LVTV_Config::GET_RADIO_CHANNEL_LIST_FOLDER_VIEWS(),$this->session));
                
        $this->add_screen(new TvFavoritesScreen($this->tv,
                LVTV_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));


        $this->add_screen(new LVTV_VodCategoryListScreen($this->session));
        $this->add_screen(new LVTV_VodCat($this->session));
        $this->add_screen(new LVTV_VodListScreen($this->session,$this->vod));
        #$this->add_screen(new LVTV_VodCategory($this->session,$this->vod));
        $this->add_screen(new VodMovieScreen($this->vod));

        $this->add_screen(new VodSeriesListScreen($this->vod));

        $this->add_screen(new VodFavoritesScreen($this->vod));

        $this->add_screen(new LVTV_VodSearchScreen($this->vod));

        #$this->add_screen(new VodGenresScreen($this->vod));

    }

    ///////////////////////////////////////////////////////////////////////
    private function get_tv_folder_views(){
        return LVTV_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS();
    }
   
}

///////////////////////////////////////////////////////////////////////////
?>
