<?php
///////////////////////////////////////////////////////////////////////////

#require_once 'lib/abstract_preloaded_regular_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_Radio_ChannelListScreen extends TvChannelListScreen implements UserInputHandler {

    const ID = 'radio_channel_list';

    public static function get_media_url_str($group_id){
        return MediaURL::encode(
            array(
                'screen_id' => self::ID,
                'group_id'  => $group_id,
            )
        );
    }

    ///////////////////////////////////////////////////////////////////////

    protected $tv;
    private $session;
    ///////////////////////////////////////////////////////////////////////

    public function __construct(Tv $tv, $folder_views,$session){
        parent::__construct($tv, $folder_views,self::ID);

        $this->tv = $tv;
	$this->session = $session;
        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
        $actions = array();
        $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::tv_play();
        $actions[GUI_EVENT_KEY_PLAY] = ActionFactory::tv_play();

        $actions[GUI_EVENT_KEY_INFO] =
            UserInputHandlerRegistry::create_action(
                $this, 'info');

        return $actions;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_archive(MediaURL $media_url){ 
        return $this->session->get_archive();
    }
    ///////////////////////////////////////////////////////////////////////
}

///////////////////////////////////////////////////////////////////////////
?>
