<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_SetupScreen extends AbstractControlsScreen {

	const ID = 'setup';
	private $session;
	const EPG_FONTSIZE_DEF_VALUE	= 'normal';
	private	$epg_font_size;
    ///////////////////////////////////////////////////////////////////////
   public static function get_media_url_str(){
        return MediaURL::encode(
            array(
                'screen_id' => self::ID,
            )
        );
    }
    public function __construct($session,$tv){
        parent::__construct(self::ID);

        $this->session = $session;
        $this->tv = $tv;
        
	$this->manifest = simplexml_load_file(DuneSystem::$properties['install_dir_path']."/dune_plugin.xml");
	
    }

    public function do_get_control_defs(&$plugin_cookies){
        $defs = array();
		$epg_font_size = isset($plugin_cookies->epg_font_size) ? $plugin_cookies->epg_font_size : self::EPG_FONTSIZE_DEF_VALUE;
        $show_tv = isset($plugin_cookies->show_tv) ? $plugin_cookies->show_tv : 'yes';
        $show_vod = isset($plugin_cookies->show_vod) ? $plugin_cookies->show_vod : 'yes';
	
		$this->add_label($defs,$this->manifest->name.' DUNE Plugin ', 'Vers: '.$this->manifest->version);
	
        $show_ops = array();
        $show_ops['yes'] = T::t('yes');
        $show_ops['no'] = T::t('no');

        $this->add_combobox(
	    $defs,
            'show_tv', 
            'Показывать плагин в главном меню:',
            $show_tv, 
            $show_ops, 
            700, 
            true
        );

	$islogged = $this->session->is_logged_in();
	#$islogged = false;
	hd_print("is_logged->>>>: $islogged");
	$is_login_correct = isset($plugin_cookies->is_login_correct) ? $plugin_cookies->is_login_correct : false;
	hd_print("is_login_correct:$is_login_correct");
	if ($is_login_correct == 1 && $islogged === false){
// 		hd_print(T::t('authorisation_attempt'));
		$this->session->login_lvtv($plugin_cookies);
	}
	
	if ($is_login_correct == 1){
		#hd_print("is_login_correct1: $is_login_correct");
		#if ($islogged === false)
		#	{
		#		hd_print("попытка авторизации");
		#		$this->session->login_lvtv($plugin_cookies);
		#	}
		$acc_info = $this->session->get_account();
		$acc_title = isset($acc_info->login) ? strval($acc_info->login) : T::t('unavailable');
		hd_print("acc_title: $acc_title");
		$acc_packet_name = isset($acc_info->title) ? strval($acc_info->title) : T::t('unavailable');
		hd_print("acc_packet_name:$acc_packet_name");
		$acc_tmp = isset($acc_info->expire) ? intval($acc_info->expire) : 0;
		hd_print("time:$acc_tmp");
		$acc_subscr_end = date("d.m.y",$acc_tmp) . " " . date("H:i",$acc_tmp);
		hd_print("end:$acc_subscr_end");

		$acc_settings = $this->session->get_settings_lvtv();
		$acc_time_shift = $acc_settings->timeshift;
		$time_shift = isset($acc_time_shift->val) ? intval($acc_time_shift->val) : 0;
		hd_print("time_shift:$time_shift");
		$plugin_cookies->time_shift = $time_shift;
		$time_shift_ops = array();
		#$time_shift_ops[intval($time_shift)] = $time_shift;
		foreach ($acc_time_shift->values->children()  as $time_shift_list){
			hd_print("timeshift_val: $time_shift_list");
			$time_shift_ops[intval($time_shift_list)] = strval($time_shift_list);
		}
		$acc_buffer_time = $acc_settings->http_caching;;
		$buffer_time = isset($acc_buffer_time->val) ? intval($acc_buffer_time->val) : 0;
			
		hd_print("buffer_time:$buffer_time");
		$plugin_cookies->buf_time = $buffer_time;
		$buffer_time_ops = array();
		foreach ($acc_buffer_time->values->children() as $buffer_time_list){
			hd_print("buff: $buffer_time_list");
			$buffer_time_ops[intval($buffer_time_list)] = strval($buffer_time_list);
		}

	}else{
                $acc_title = T::t('unavailable');
                $acc_packet_name = T::t('unavailable');
                $acc_subscr_end = T::t('unavailable');
	}
	$this->add_label($defs,T::t('login'), $acc_title . ' (' . $acc_packet_name . ')');
	#$this->add_label($defs,T::t('package_name'), $acc_packet_name);
	$this->add_label($defs,T::t('expiration_date'), $acc_subscr_end);
        $this->add_button($defs, 'edit_subscription', null, T::t('edit_subscription'), 0);
        
	//hd_print("rrrrr_correct: $is_login_correct");
	if ($is_login_correct == 1){ 
	
		$this->add_button(
			    $defs, 
			    'edit_pcode', 
			    T::t('pcode'), 
			    T::t('edit_1'), 
			    700
		);
	
		$this->add_combobox(
			    $defs,
			    'http_caching',
			    T::t('buffer_time'),
			    $buffer_time, 
			    $buffer_time_ops,
			    700,
			    true
		);

		$this->add_combobox(
			    $defs,
			    'timeshift',
			    T::t('timeshift'),
			    $time_shift, $time_shift_ops, 0, true
		);

	}else{
		$this->add_label($defs,T::t('buffer_time'), T::t('unavailable'));
		$this->add_label($defs,T::t('timeshift'), T::t('unavailable'));

	}
	#$lvtv_url = isset($plugin_cookies->lvtv_url) ? $plugin_cookies->lvtv_url : 'http://irij.lvtv.eu';
	#$this->add_text_field($defs,
        #        'lvtv_url', 'URL сервера:',
        #        $lvtv_url, 0, 0, 0, 1, 400, 0, true);
        
// 	$this->add_button($defs, 'edit_url', null, T::t('edit_server_url'), 0);
		///////////////////////epg font//////////////////////////////////////
			$epg_font_size_ops = array();
			$epg_font_size_ops ['normal'] = 'Обычный';
			$epg_font_size_ops ['small'] = 'Мелкий';
			$this->add_combobox($defs,
				'epg_font_size', 'Размер шрифта EPG:', 
				$epg_font_size, $epg_font_size_ops, 700, true);
			////////////////////////////icons////////////////////////////////////
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies){
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies){
        hd_print('Setup: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");
	$need_close_dialog = false;
	$need_reset_controls = false;
	$post_action = null;
        #hd_print("Setup: changing $control_id value to $new_value");

        if ($user_input->action_type === 'confirm'){

	    $control_id = $user_input->control_id;
	    $new_value = $user_input->{$control_id};	    
	    
            if ($control_id === 'show_tv'){
                $plugin_cookies->show_tv = $new_value;
                
            }else if ($control_id === 'show_vod'){
                $plugin_cookies->show_vod = $new_value;
                
	    }
		///////////////////////////////////////////////////
		else if ($control_id == 'epg_font_size')
			{
				$plugin_cookies->epg_font_size = $new_value;
			}
		//////////////////////////////////////////////////
		else if ($control_id === 'timeshift' || 'http_caching'){
		$this->session->set_settings_lvtv($control_id, $new_value);
		$this->tv->unload_channels();
		
	    }
            $need_reset_controls = true;
            
        }else if ($user_input->action_type === 'apply'){
	    $control_id = $user_input->control_id;
	    hd_print("idcon:$control_id");
	    if ($control_id === 'edit_subscription'){
		return $this->do_get_edit_subscription_action($plugin_cookies, $this);
		
	    }elseif ($control_id === 'edit_url'){
		return $this->do_get_edit_url_action($plugin_cookies, $this);
		
	    }elseif ($control_id === 'reset_url'){
		$islogged = $this->session->is_logged_in();
		if($islogged === true) $this->session->unset_login();
		$plugin_cookies->lvtv_url = 'http://irij.lvtv.eu';
		if (isset($plugin_cookies->login) && isset($plugin_cookies->pass)){
			try{
				$this->session->login_lvtv($plugin_cookies);
			}catch (DuneException $e){
				#return ActionFactory::show_error(false,'Ошибка',array('Связь с сервером не установлена'));
				$post_action = $e->get_error_action();
			}
		}
		$need_close_dialog = true;
               	$need_reset_controls = true;
               	
	    }elseif ($control_id === 'apply_url'){
			if($islogged === true) $this->session->unset_login();
			$plugin_cookies->lvtv_url = $user_input->lvtv_url;
			if (isset($plugin_cookies->login) && isset($plugin_cookies->pass)){
				try{
					$this->session->login_lvtv($plugin_cookies);
				}catch (DuneException $e){
					return ActionFactory::show_error(false,'Error',array(T::t('no_connection')));
					#$post_action = $e->get_error_action();
				}
			}
			$need_close_dialog = true;
                	$need_reset_controls = true;
			
	    }
		
		elseif ($control_id === 'apply_sub')
		{
			if ($user_input->login === '' || $user_input->pass === '')
			{
				return ActionFactory::show_error(false,'Error',array(T::t('field_login_or_pass')));
			}
			$plugin_cookies->login = $user_input->login;
                        $plugin_cookies->pass = $user_input->pass;
			$this->session->logout_lvtv($plugin_cookies);	/////new
			#$islogged = $this->session->is_logged_in();
		/*	if ($islogged == true)
			{
				$this->session->logout_lvtv();
			}
		*/
			$post_action = null;
			try
			{
				$this->session->try_login($plugin_cookies, false);
			}
			catch (DuneException $e)
			{
				$post_action = $e->get_error_action();
                    return $post_action;
			}
			$need_close_dialog = true;
            $need_reset_controls = true;
                	#$plugin_cookies->logiin = true;
			hd_print("gfhdhfh");
			
	    }
		elseif ($control_id === 'close'){
	     //return null;
  		$need_reset_controls = true;
  		$need_close_dialog = true;

	    }elseif ($control_id === 'edit_pcode') {
                return $this->do_get_edit_pcode_action($plugin_cookies, $this);
                
            }elseif ($control_id === 'apply_pcode') {
                 try {
// 		      throw new Exception("Exception message pcode");
                      $this->session->set_pcode_lvtv(
                         $user_input->current_pcode,
                         $user_input->new_pcode,
                         $user_input->new_pcode_copy
                      );
                 } catch (DuneException $e) {
		       $post_action = $e->get_error_action();
//                     return $e->get_error_action();
                 }
// 
                 $need_close_dialog = true;
                 $need_reset_controls = true;
            }
		
			else{
	     //return null;
  		$need_reset_controls = true;
  		$need_close_dialog = true;
  	    }
        }
        
	if ($need_reset_controls){
            $defs = $this->do_get_control_defs($plugin_cookies);
	    //hd_print("uuuuuuuuuuuuu");
            $reset_controls_action = ActionFactory::reset_controls($defs, $post_action);

            if ($need_close_dialog){
                return ActionFactory::close_dialog_and_run($reset_controls_action);
            }

            return $reset_controls_action;
         }
    }

    private function do_get_edit_pcode_defs(&$plugin_cookies, $handler, $add_params){
        $defs = array();

        ControlFactory::add_text_field($defs, $handler, $add_params, 'current_pcode' ,  T::t('current_pcode')  ,   '',  true, true,  false, false, 500);
        ControlFactory::add_text_field($defs, $handler, $add_params, 'new_pcode'     ,  T::t('new_pcode')    ,   '',  true, true,  false, false, 500);
        ControlFactory::add_text_field($defs, $handler, $add_params, 'new_pcode_copy',  T::t('new_pcode_copy'),   '',  true, true,  false, false, 500);        
        ControlFactory::add_vgap($defs, 50);
        ControlFactory::add_button($defs, $handler, $add_params, 'apply_pcode', null, T::t('apply'), 300);
        ControlFactory::add_vgap($defs, -3);
        ControlFactory::add_button($defs, $handler, $add_params, 'close',null,T::t('close'), 300);        
        
        return $defs;
    }    
    
    private function do_get_edit_pcode_action(&$plugin_cookies, $handler, $add_params = null){
	$message = T::t('change_pcode');
        return ActionFactory::show_dialog(
            $message,
            $this->do_get_edit_pcode_defs($plugin_cookies, $handler, $add_params),
            true
        );
    }    
    
    public function do_get_edit_subscription_defs(&$plugin_cookies, $handler, $add_params){
		$defs = array();
		
		$login = isset($plugin_cookies->login) ? $plugin_cookies->login : '';
        	$pass = isset($plugin_cookies->pass) ? $plugin_cookies->pass : '';
		ControlFactory::add_text_field($defs, $handler, $add_params, 'login', T::t('login'), $login, true, false, false, true,  500);
        	ControlFactory::add_text_field($defs, $handler, $add_params, 'pass',  T::t('pass'),   $pass,  true, true,  false, false, 500);

        	ControlFactory::add_vgap($defs, 50);

        	ControlFactory::add_button($defs, $handler, $add_params, 'apply_sub', null, T::t('apply'), 300);

        	ControlFactory::add_vgap($defs, -3);
        	ControlFactory::add_button($defs, $handler, $add_params, 'close',null,T::t('close'), 300);



        	return $defs;
   }  
	
   public function do_get_edit_subscription_action(&$plugin_cookies, $handler, $add_params = null) {
		$message = T::t('enter_account_and_password');
        	return ActionFactory::show_dialog(
            		$message,
            		$this->do_get_edit_subscription_defs($plugin_cookies, $handler, $add_params),
			true
            	);

   }

   private function do_get_edit_url_defs(&$plugin_cookies, $handler, $add_params){
		$defs = array();
		$lvtv_url = isset($plugin_cookies->lvtv_url) ? $plugin_cookies->lvtv_url : 'http://irij.lvtv.eu';
		ControlFactory::add_text_field($defs, $handler, $add_params, 'lvtv_url', T::t('lvtv_url'), $lvtv_url, false, false, false, true, 500);
        	ControlFactory::add_button($defs, $handler, $add_params, 'apply_url', null, T::t('apply'), 300);
        	ControlFactory::add_button($defs,$handler,$add_params, 'close',null,T::t('close'), 300);
		ControlFactory::add_button($defs, $handler, $add_params, 'reset_url', null, T::t('reset_url'), 1000);

		return $defs;
   }

   public function do_get_edit_url_action(&$plugin_cookies, $handler, $add_params = null ){
		$message = T::t('change_server_url');
        	return ActionFactory::show_dialog(
            		$message,
            		$this->do_get_edit_url_defs(
                	$plugin_cookies, $handler, $add_params),
            		true);

   }


}

///////////////////////////////////////////////////////////////////////////
?>
