<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';


require_once 'lvtv_channel.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_Tv extends AbstractTv {
    public $cookie = array();
    private $session;
    private $x=0;
    
    public function __construct($session){
	$this->session = $session;
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            LVTV_Config::TV_FAVORITES_SUPPORTED,
            true
        );
    }

    public function get_fav_icon_url(){
        return $this->session->get_icon('tv_fav.png');
    }

    ///////////////////////////////////////////////////////////////////////
    public function newload(&$plugin_cookies){
	hd_print('unload');
	if(is_null($this->channels) && is_null($this->groups)){
		$this->load_channels($plugin_cookies);
	}
    }
	
    /* protected function load_channels(&$plugin_cookies){
	$group_tmp = null;
    #hd_print("get_login");
	$this->session->check_login($plugin_cookies);
    $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
    $this->channels = new HashedArray();
    $this->groups = new HashedArray();
    if ($this->is_favorites_supported()){
        $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    'Избранное',
                    $this->session->get_icon('tv_fav.png')
                )
            );
        }



        $this->groups->put( 
		new AllChannelsGroup(
            	    $this,
            	    'Все каналы',
            	    $this->session->get_icon('tv_all.png')
            	)
        );
	#$this->session->get_dir_tree();
	#$id_tv = $this->session->get_tv_id();
	#$id_radio = $this->session->get_radio_id();
	$chanel_number = 1;
	$tv_ = $this->session->tv;
	$xml_groups_tv = $this->session->get_dir($tv_);

	$gp = 0;
    foreach ($xml_groups_tv->items->children() as $xml_tv_category)
	{
	$gp++;
	if ($gp >=2)
		{
		    $group_icon = 'tv_'.strval($xml_tv_category->cid) . ".png";
        	$group_lvtv = 
			new DefaultGroup(
                	strval($xml_tv_category->cid),
                    strval($xml_tv_category->title),
                    $this->session->get_icon($group_icon)
                    );
                    
		    $tv_group = intval($xml_tv_category->cid);
			//unset($tv_group[86]);
		    $xml_tv_group = $this->session->get_dir($tv_group);
		    
 		    hd_print("xx22-->>".$xml_tv_group);
		    foreach ($xml_tv_group->items->children() as $xml_tv_channel)
			{
			    $icon1 = strval($xml_tv_channel->mid).".jpg";
			    $icon = $this->session->get_icon($icon1);
            		$channel =
                  		new LVTV_Channel(
                      		intval($xml_tv_channel->mid),
                      		strval($xml_tv_channel->title),
                      		$icon,
							"",
							$chanel_number,
                      		20,
                      		7,
                      		$buf_time,
							intval($xml_tv_channel->protected),
							intval($xml_tv_channel->arch),
							1);
				++$chanel_number;
			    $this->channels->put($channel); 		//!
				
				$channel->add_group($group_lvtv);		//$channel->add_group($group);
				$group_lvtv->add_channel($channel);		//$group->add_channel($channel);
			}
			#Link group and channel.
		    $group_tmp [] = $group_lvtv;
        }

	}
	$radio_ = $this->session->radio;
 	$xml_groups_radio = $this->session->get_dir($radio_);
	$icon_radio = 'tv_'.strval($xml_groups_radio->cid) . ".png";
        $group_lvtv = new DefaultGroup(
                		strval($xml_groups_radio->cid),
                    		strval($xml_groups_radio->title),
                    		$this->session->get_icon($icon_radio)
        );
        
	$lvtv_url = $this->session->get_lvtv_url();
	foreach ($xml_groups_radio->items->children() as $xml_tv_channel){

			$mid = intval($xml_tv_channel->mid);
			$icon1 = $mid.".png";
			$icon = $this->session->get_icon($icon1);
            		$channel = new LVTV_Channel(
                      	$mid,
                      	strval($xml_tv_channel->title),
                      	$icon,
						"",
						$chanel_number,
                      	0,
                      	0,
                      	$buf_time,
	              		0, 
		      		    intval($xml_tv_channel->arch),
		      		    0
			);
			++$chanel_number;
			$this->channels->put($channel);
             		$channel->add_group($group_lvtv);
             		$group_lvtv->add_channel($channel);
			
	}
	
	$group_tmp [] = $group_lvtv;
	$i=0;
	foreach ($group_tmp as $g){
		$size = $g->get_channels($plugin_cookies)->size();
		#hd_print("size:$size"); 
        	if ($size == 0){
             		hd_print("пустая группа");
        	}else{
			$this->groups->put($g);
        	}
 	}

     } */
	protected function load_channels(&$plugin_cookies)
    {
		/////////////////////////////
		$settings = $this->session->get_settings();
        if (empty($settings))
            {
// !!!                $this->session->api_get_settings();
                $settings = $this->session->get_settings();
            }
		if (!isset($plugin_cookies->buf_time))
		{
			$buf_time = intval($settings->settings->buffer);
			hd_print ("buf_time_list---->$buf_time");
			$plugin_cookies->buf_time = $buf_time;
		}
		else
		{
			$buf_time = $plugin_cookies->buf_time;
		}
		
		////////////////////////////
        #$this->session->check_logged_in();
		$this->session->check_login($plugin_cookies);
        $xml = $this->session->api_get_groups_tv();
		$buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();

        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    'Избранное',
                    $this->session->get_icon('tv_fav.png')));
        }

        $this->groups->put(
            new AllChannelsGroup(
                $this,
                'Все каналы',
                $this->session->get_icon('tv_all.png')));
	
        $chanel_number = 1;
        foreach ($xml->groups->children() as $xml_tv_category)
        {
            if ($xml_tv_category->getName() !== 'item')
            {
                hd_print("Error: unexpected node '" . $xml_tv_category->getName() .
                    "'. Expected: 'item'");
                throw new Exception('Invalid XML document');
            }
			
			$group_icon = 'tv_'.strval($xml_tv_category->id) . ".png";
			$group_icon = str_replace('tv_63.png', 'tv_all.png', $group_icon);
			
			#hd_print("group_icon------->$group_icon");
            $this->groups->put(
                new DefaultGroup(
                    strval($xml_tv_category->id),
                    strval($xml_tv_category->name),
                    $this->session->get_icon($group_icon)));
        
			foreach ($xml_tv_category->channels->children() as $xml_tv_channel)
            {
                if ($xml_tv_channel->getName() !== 'item')
                {
                    hd_print("Error: unexpected node '" . $xml_tv_channel->getName() .
                        "'. Expected: 'item'");
                    throw new Exception('Invalid XML document');
                }
				
				try
                {
                    $channel = $this->get_channel(intval($xml_tv_channel->id));
                }
                catch (Exception $e)
                {
				///////////////////////////////////////////////////////////////////////////////////
				if(intval($xml_tv_channel->is_video == '1'))
				{
				$mid = intval($xml_tv_channel->id);
				$icon1 = $mid . ".jpg";
				}
				else
				{
				$mid = intval($xml_tv_channel->id);
				$icon1 = $mid . ".png";	
				}
				
				#hd_print("icon1------->$icon1");
				$icon = $this->session->get_icon($icon1);
				$channel =
                        new LVTV_Channel
                            (
                                strval($xml_tv_channel->id),
                                strval($xml_tv_channel->name),
                                $icon,
                                "",
                                $chanel_number,
                                14,
                                2,
                                $buf_time,
                                intval($xml_tv_channel->protected),
                                intval($xml_tv_channel->have_archive),
								intval($xml_tv_channel->is_video)
                            );
                    ++$chanel_number;
                    $this->channels->put($channel);
				}
            $tv_category_id = intval($xml_tv_category->id);
			if($tv_category_id == strval(63) && $tv_category_id == strval(74))
				continue;
            $group = $this->groups->get($tv_category_id);
            #Link group and channel.
            $channel->add_group($group);
            $group->add_channel($channel);
			
        }
	
		#remove empty groups
		$temp_groups = new HashedArray();
		foreach($this->get_groups() as $g)
			if($g->is_favorite_channels() or ($g->get_channels($plugin_cookies) != NULL and $g->get_channels($plugin_cookies)->size()))
				$temp_groups->put($g);
			else
				hd_print("Group " . $g->get_title() . " removed: no channels");
		$this->groups = $temp_groups;
		
		}
    }
    ///////////////////////////////////////////////////////////////////////////
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
	{
        $this->ensure_channels_loaded($plugin_cookies);

	$this->session->check_login($plugin_cookies);
	#$this->session->status_lvtv();	    
        $cid = $this->get_channel($channel_id)->get_id();
        $time_shift = isset($plugin_cookies->time_shift) ? $plugin_cookies->time_shift : 0 ;
        $cc = $this->get_channel($channel_id)->is_video();
	$t = $this->get_channel($channel_id)->is_protected();
	#hd_print("TTTT--->>>  $t");
	#hd_print("channel:--->>> channel:$cid, archive:$archive_ts, protect:$protect_code");
	/////////////////////////////////////////////////
	if($this->get_channel($channel_id)->is_protected() && $protect_code == '')
	{
			hd_print("No protect code supplied for protected channel");
			throw new DuneException(
					'No protect code supplied for protected channel', 99,
					ActionFactory::show_error(false, 'No protect code supplied for protected channel', array()));
	}
		
       #hd_print("channel:--->>> channel:$cid, archive:$archive_ts, protect:$protect_code");
		//////////////////////////////igores////////////////////////////////////
// 		if($cc == 0)
// 		{
// 			$xml = $this->session->get_url_tv_lvtv($cid, null, null, $time_shift, $plugin_cookies);
// 			#hd_print("XML:--->>>  $xml");
// 			$url = str_ireplace('http://', 'http://audio_stream://', $xml);
// 			
// 
// 		}
// 		//////////////////////////////////////////////////////////
// 		else
// 		{
	$url = $this->session->get_url_tv_lvtv($cid, $archive_ts, $protect_code, $time_shift, $plugin_cookies);
// 	$url = str_ireplace("http://","http://ts://",$url);
		
		
// 		}
        hd_print("URL:--->>>  $url");
//         return $url;
	$urll = DuneSystem::$properties['plugin_cgi_url'];
	$urll = str_ireplace("http://","http://ts://",$urll);
	$urll .= "lvtv.sh?$url";
	hd_print("url posle $urll");
	return $urll;	     
	
    }

    /*
    
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies){
        $this->ensure_channels_loaded($plugin_cookies);

	$this->session->check_login($plugin_cookies);
	#$this->session->status_lvtv();	    
        $cid = $this->get_channel($channel_id)->get_id();
        $time_shift = isset($plugin_cookies->time_shift) ? $plugin_cookies->time_shift : 0 ;
	$is_video = $this->get_channel($channel_id)->is_video();
	hd_print("--->>> is_video: $is_video"); 	
	$url = $this->session->get_url_tv_lvtv($cid,$archive_ts,$protect_code,$time_shift,$is_video);
	hd_print("--->>> URL: $url");
	
	
	$urll = DuneSystem::$properties['plugin_cgi_url'];
	$urll = str_ireplace("http://","http://ts://",$urll);
	$urll .= "lvtv.sh?$url";
	hd_print("url posle $urll");
	return $urll;	     
        //return $url;
    }    
    */
    
    ///////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies){
        $epg = array();

        hd_print("--->>> day_start_ts: $day_start_ts");
        #$day = HD::format_timestamp($day_start_ts, "dmy");

	$this->session->check_login($plugin_cookies);
	$is_video = $this->get_channel($channel_id)->is_video();
	if($is_video == 0){
		$epg[] =
                new DefaultEpgItem(
                    "Программа для радио отсутствует",
                    "radio",//strval($epg_item->description),
                    "",//intval($epg_item->begin),
                    0/*intval($epg_item->stop_time)*/
                );
	}else{
        	$time_shift = isset($plugin_cookies->time_shift) ? $plugin_cookies->time_shift : 0;
		$xml = $this->session->get_epg($day_start_ts,$channel_id);

        	foreach ($xml->items->children() as $epg_item){
            		if ($epg_item->getName() !== 'item'){
                		hd_print("Error: unexpected node '" . $epg_item->getName() .
                    		"'. Expected: 'item'");
                		throw new Exception('Invalid XML document');
            		}
            		
            	$start_epg = intval($epg_item->start);
	    		$stop_epg = intval($epg_item->stop);
	    		$descrption_epg = isset($epg_item->description) ? strval($epg_item->description) : "  ";
	    		
            		if ($time_shift >=1){
        	    		$epg_start_plus = $time_shift * 3600;
        	    		$start_epg = $start_epg + $epg_start_plus;
        	    		$stop_epg = $stop_epg + $epg_start_plus;
        		}
        		
			$epg[] = new DefaultEpgItem(
				strval($epg_item->title),
				$descrption_epg,//strval($epg_item->info),
				$start_epg,
				$stop_epg
			);//0);//intval($epg_item->stop_time));
	 	}
	}

	return new EpgIterator(
		$epg,
		$day_start_ts,
		$day_start_ts + 86400
	);
    }

    public function folder_entered(MediaURL $media_url, &$plugin_cookies){
        $this->session->check_login($plugin_cookies);
    }

    public function get_archive(MediaURL $media_url){
	return $this->session->get_archive();
    }


}
///////////////////////////////////////////////////////////////////////////
?>
