<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/tv/tv_group_list_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_TvGroupListScreen extends TvGroupListScreen
{
    const ID = 'tv_group_list';

    ///////////////////////////////////////////////////////////////////////

    protected $tv;
    public static function get_media_url_str(){
        return MediaURL::encode(
            array
            (
                'screen_id' => self::ID,
            ));
    }
    ///////////////////////////////////////////////////////////////////////

    public function __construct($tv, $folder_views){
        parent::__construct(self::ID, $folder_views);

        $this->tv = $tv;
    }
    
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->tv->folder_entered($media_url, $plugin_cookies);

        $this->tv->ensure_channels_loaded($plugin_cookies);

        $items = array();

        foreach ($this->tv->get_groups() as $group){
            $media_url = $group->is_favorite_channels() ?
				    TvFavoritesScreen::get_media_url_str() :
				    LVTV_TvChannelListScreen::get_media_url_str($group->get_id());
				    
	    if($group->get_id() != 63 && $group->get_id() != 74){
            	$items[] = array(
                	PluginRegularFolderItem::media_url => $media_url,
                	PluginRegularFolderItem::caption => $group->get_title(),
                	PluginRegularFolderItem::view_item_params => array(
                    		ViewItemParams::icon_path => $group->get_icon_url(),
                    		ViewItemParams::item_detailed_icon_path => $group->get_icon_url()
                	)
            	);
	    }
        }

        $this->tv->add_special_groups($items);

        return $items;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_archive(MediaURL $media_url){
        return $this->tv->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
