<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lvtv_vod_category.php';
require_once 'lvtv_vod_list_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_VodCat extends AbstractPreloadedRegularScreen
{
    const ID = 'vod_cat';

    public static function get_media_url_str($category_id)
    {
        return MediaURL::encode(
            array
            (
                'screen_id'     => self::ID,
                'category_id'   => $category_id,
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    private $category_list;
#    private $category_index;
    private $session;
    ///////////////////////////////////////////////////////////////////////

    public function __construct($session)
    {
        parent::__construct(
            self::ID, $this->get_folder_views());
	$this->session = $session;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        return array(
            GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
	$this->session->check_login($plugin_cookies);
        $this->fetch_cat($media_url->category_id);
	hd_print("cat:$media_url->category_id");
        $category_list = $this->category_list;
        $this->is_root = true;
        $items = array();
        foreach ($category_list as $c){
	    $media_url_str = LVTV_VodListScreen::get_media_url_str($c->get_id());
            $items[] = array
            (
                PluginRegularFolderItem::media_url => $media_url_str,
                PluginRegularFolderItem::caption => $c->get_caption(),
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $c->get_icon_path(),
                    ViewItemParams::item_detailed_icon_path => $c->get_icon_path()
                )
            );
        }

        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

     private function fetch_cat($cid)
	{
		$this->category_list = array();
		$xml = $this->session->get_dir($cid);
		foreach ($xml->items->children() as $c)
		{
                        $ic = "vod_cat.png";
                        $icon = $this->session->get_icon($ic);
			hd_print("ii:$icon");
			$cat = new LVTV_VodCategory(
                    			strval($c->cid),
                    			strval($c->title),
                    			$icon);
			$this->category_list[] = $cat;
		}
	}
    ///////////////////////////////////////////////////////////////////////
    #public function get_archive(MediaURL $media_url)
    #{ 
    #    return $this->session->get_archive();
    #}
    private function get_folder_views()
    {
    	return LVTV_Config::GET_VOD_CAT_LIST_FOLDER_VIEWS();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
