<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lvtv_vod_category.php';
require_once 'lvtv_vod_list_screen.php';
require_once 'lvtv_vod_cat.php';
require_once 'lvtv_vod_search_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_VodCategoryListScreen extends AbstractPreloadedRegularScreen {
    const ID = 'vod_category_list';

    public static function get_media_url_str(){
        return MediaURL::encode(
            array
            (
                'screen_id'     => self::ID,
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    private $category_list;
    #private $category_index;
    private $session;
    ///////////////////////////////////////////////////////////////////////

    public function __construct($session){
        parent::__construct(
            self::ID, $this->get_folder_views());
	$this->session = $session;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
        return array(
            GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
	$this->session->check_login($plugin_cookies);
        if (is_null($this->category_list)) $this->fetch_cat();

        $category_list = $this->category_list;
        $items = array();

        if (LVTV_Config::VOD_FAVORITES_SUPPORTED){
    	    $icon_fav = $this->session->get_icon("vod_fav.png");
            $items[] = array(
                PluginRegularFolderItem::media_url => VodFavoritesScreen::get_media_url_str(),
                PluginRegularFolderItem::caption => 'Избранное',
                PluginRegularFolderItem::view_item_params => array(
                    ViewItemParams::icon_path => $icon_fav,
                    ViewItemParams::item_detailed_icon_path => $icon_fav,
                )
            );
        }
        
    	$icon_search = $this->session->get_icon("vod_search.png");
        $items[] = array(
                PluginRegularFolderItem::media_url => LVTV_VodSearchScreen::get_media_url_str(),
                PluginRegularFolderItem::caption => 'Поиск' ,
                PluginRegularFolderItem::view_item_params => array(
                    ViewItemParams::icon_path => $icon_search,
                    ViewItemParams::item_detailed_icon_path => $icon_search,
                )
        );
            
        foreach ($category_list as $c){
 
	    $media_url_str = LVTV_VodCat::get_media_url_str($c->get_id());

            $items[] = array(
                PluginRegularFolderItem::media_url => $media_url_str,
                PluginRegularFolderItem::caption => $c->get_caption(),
                PluginRegularFolderItem::view_item_params => array(
                    ViewItemParams::icon_path => $c->get_icon_path(),
                    ViewItemParams::item_detailed_icon_path => $c->get_icon_path()
                )
            );
        }

        return $items;
    }

     private function fetch_cat(){
	$cid = $this->session->vod;
	$xml = $this->session->get_dir($cid);
	foreach ($xml->items->children() as $c){
	    if(strval($c->cid) != -1){
		$ic = "vod_" . strval($c->cid). ".png";
		$icon = $this->session->get_icon($ic);
		$cat = new LVTV_VodCategory(
       			strval($c->cid),
       			strval($c->title),
       			$icon
       		);
		$this->category_list[] = $cat;
	    }
	}
    }
	
    ///////////////////////////////////////////////////////////////////////
    public function get_archive(MediaURL $media_url){ 
        return $this->session->get_archive();
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
    	return LVTV_Config::GET_VOD_CATEGORY_LIST_FOLDER_VIEWS();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
