<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/tv/tv_channel_list_screen.php';

///////////////////////////////////////////////////////////////////////////

class LVTV_Radio_ChannelListScreen extends TvChannelListScreen implements UserInputHandler {
    const ID = 'radio_channel_list';

    public static function get_media_url_str($group_id){
        return MediaURL::encode(
            array(
                'screen_id' => self::ID,
                'group_id'  => $group_id,
            )
        );
    }

    ///////////////////////////////////////////////////////////////////////

    protected $tv;

    ///////////////////////////////////////////////////////////////////////

    public function __construct(Tv $tv, $folder_views){
        parent::__construct(self::ID, $folder_views);

        $this->tv = $tv;

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
        $actions = array();
        $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::tv_play();
        $actions[GUI_EVENT_KEY_PLAY] = ActionFactory::tv_play();

        $actions[GUI_EVENT_KEY_INFO] = UserInputHandlerRegistry::create_action(
                $this, 'info'
        );

        return $actions;
    }

    public function get_archive(MediaURL $media_url){
        return $this->tv->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
